﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Diagnostics;
using Infragistics.Windows.Editors;

namespace SelectedItemChangedOnComboColumn
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            ManageRecipeStateResults = new List<Data>
            {
                new Data
                {
                    RecipeKey = 1,
                    MandatoryCriteriaList = "some",
                    RecipeVersion = 1,
                    PreviousRecipeState = true,
                    CurrentRecipeState = "State 1"
                },
                new Data
                {
                    RecipeKey = 2,
                    MandatoryCriteriaList = "some 1",
                    RecipeVersion = 2,
                    PreviousRecipeState = true,
                    CurrentRecipeState = "State 2"
                }
            };

            DataContext = this;
        }

        public List<Data> ManageRecipeStateResults { get; set; }


    }

    public class IsItemValidConverter : IValueConverter
    {
        object lastSetValue = null;
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            lastSetValue = value;
            return value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (lastSetValue.Equals("State 1")
                && (value.Equals("State 5")))
            {                
                MessageBox.Show("State 5 is not valid when State 1 is selected!!!");
                return lastSetValue;
            }
            if (lastSetValue.Equals("State 2")
                && (value.Equals("State 4") || value.Equals("State 5")))
            {
                MessageBox.Show("State 4 and State 5 is not valid when State 2 is selected!!!");
                return lastSetValue;
            }
            return value;
        }
    }


    public class Data
    {
        public int RecipeKey { get; set; }
        public string MandatoryCriteriaList { get; set; }
        public int RecipeVersion { get; set; }
        public bool PreviousRecipeState { get; set; }
        public string CurrentRecipeState { get; set; }
        public bool IsPreserved { get; set; }
    }


    public class OptionList : List<ComboData>
    {
        public OptionList()
        {
            Add(new ComboData { State = "State 1" });
            Add(new ComboData { State = "State 2" });
            Add(new ComboData { State = "State 3" });
            Add(new ComboData { State = "State 4" });
            Add(new ComboData { State = "State 5" });
        }
    }

    public class ComboData
    {
        public string State { get; set; }
    }
}
